'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _socket = require('socket.io-client');

var _socket2 = _interopRequireDefault(_socket);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var actionEmitMiddleware = function actionEmitMiddleware(url) {
  var connection = (0, _socket2.default)(url);
  return function (store) {
    connection.on('action', function (data) {
      var actionData = Object.assign({}, data, { remote: true });
      store.dispatch(actionData);
    });
    return function (next) {
      return function (action) {
        if (!action.remote) {
          connection.emit('action', action);
        }
        return next(action);
      };
    };
  };
};

exports.default = actionEmitMiddleware;